(*
    *** LedTest.dpr by Rickard Dahlstrand  (c)Tilde Konsult 1996 ***

    This project shows how easy it is to integrate digits in your
    application.
    I think you will find it quite easy to understand what I have done here.
    If you would like some more digits check out digitmania at...
       http://cervantes.learningco.com/kevin/digits/

    This is CREDITWARE!!!  If you use this code in you app. simply include
    this line in the bottom of your READ.ME:
    ' Thanks to rickard@tilde.se for the LEDs... '
    or if you don't like doing this, mail me and we'll discuss it!

    AND...

    I like credit in my mailbox too!!  So if you like it or if you would like
    to make it better, MAIL ME!!!

    rickard@tilde.se
*)
unit Ledtest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Led: TImageList;
    Button1: TButton;
    Edit1: TEdit;
    Panel1: TPanel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    Image10: TImage;
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image14: TImage;
    Image15: TImage;
    Image16: TImage;
    Lynx: TImageList;
    Panel2: TPanel;
    Image17: TImage;
    Image18: TImage;
    Image19: TImage;
    Image20: TImage;
    Image21: TImage;
    Image22: TImage;
    Image23: TImage;
    Image24: TImage;
    CounterTimer: TTimer;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    CycleTimer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure CounterTimerTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure CycleTimerTimer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    procedure Show_16(Numbers: String; Types: TImageList);
    procedure Show_8(Numbers: String; Types: TImageList);
    procedure Show_Im(Im: TImage; Number: Char; Types: TImageList);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  GlobalTime,TickerCount:  Integer;

implementation

{$R *.DFM}

// Copy the correct image from some TImageList to a TImage!!!
procedure TForm1.Show_Im(Im: TImage; Number: Char; Types: TImageList);
begin
  Im.Picture.Bitmap := TBitmap.Create;  // Clear the current image!
  If Number = '-' then  Types.GetBitmap( 10, Im.Picture.Bitmap)
  else If Number = ' ' then  Types.GetBitmap( 11, Im.Picture.Bitmap)
    else Types.GetBitmap( StrToIntDef(Number, 0), Im.Picture.Bitmap);
end;

// Split the 16 chars string in to little chars... and some errorhandling.
procedure TForm1.Show_16(Numbers: String; Types: TImageList);
var
  x: Integer;
begin
  if Numbers <> '' then
  begin
    x := 16 - Length(Numbers);
    if (1 - x) > 0 then Show_Im(Image1, Numbers[1-x], Types);
    if (2 - x) > 0 then Show_Im(Image2, Numbers[2-x], Types);
    if (3 - x) > 0 then Show_Im(Image3, Numbers[3-x], Types);
    if (4 - x) > 0 then Show_Im(Image4, Numbers[4-x], Types);
    if (5 - x) > 0 then Show_Im(Image5, Numbers[5-x], Types);
    if (6 - x) > 0 then Show_Im(Image6, Numbers[6-x], Types);
    if (7 - x) > 0 then Show_Im(Image7, Numbers[7-x], Types);
    if (8 - x) > 0 then Show_Im(Image8, Numbers[8-x], Types);
    if (9 - x) > 0 then Show_Im(Image9, Numbers[9-x], Types);
    if (10 - x) > 0 then Show_Im(Image10, Numbers[10-x], Types);
    if (11 - x) > 0 then Show_Im(Image11, Numbers[11-x], Types);
    if (12 - x) > 0 then Show_Im(Image12, Numbers[12-x], Types);
    if (13 - x) > 0 then Show_Im(Image13, Numbers[13-x], Types);
    if (14 - x) > 0 then Show_Im(Image14, Numbers[14-x], Types);
    if (15 - x) > 0 then Show_Im(Image15, Numbers[15-x], Types);
    if (16 - x) > 0 then Show_Im(Image16, Numbers[16-x], Types);
  end;
end;

// Split the 8 chars string in to little chars... and some errorhandling.
procedure TForm1.Show_8(Numbers: String; Types: TImageList);
var
  x: Integer;
begin
  if Numbers <> '' then
  begin
    x := 8 - Length(Numbers);
    if (1 - x) > 0 then Show_Im(Image17, Numbers[1-x], Types);
    if (2 - x) > 0 then Show_Im(Image18, Numbers[2-x], Types);
    if (3 - x) > 0 then Show_Im(Image19, Numbers[3-x], Types);
    if (4 - x) > 0 then Show_Im(Image20, Numbers[4-x], Types);
    if (5 - x) > 0 then Show_Im(Image21, Numbers[5-x], Types);
    if (6 - x) > 0 then Show_Im(Image22, Numbers[6-x], Types);
    if (7 - x) > 0 then Show_Im(Image23, Numbers[7-x], Types);
    if (8 - x) > 0 then Show_Im(Image24, Numbers[8-x], Types);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Show_16(Edit1.Text, Led);
end;

procedure TForm1.CounterTimerTimer(Sender: TObject);
begin
  GlobalTime := GlobalTime + 1;
  Show_8(IntToStr(GlobalTime), Lynx);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Show_16(Edit1.Text, Lynx);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  If Key = #13 then
  begin
    Button1Click(self);
    Key := #0;
  end;
end;

procedure TForm1.CycleTimerTimer(Sender: TObject);
begin
  Show_16( copy('                ' + Edit1.Text + '                ',TickerCount,16), Led);
  If TickerCount = (Length('                ' + Edit1.Text + '                ')- 16) then TickerCount := 0;
  TickerCount := TickerCount + 1;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  CycleTimer.Enabled := True;
  Button3.Enabled := False;
  Button4.Enabled := True;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  CycleTimer.Enabled := False;
  Button4.Enabled := False;
  Button3.Enabled := True;
end;

end.
